> ## Documentation Index
> Fetch the complete documentation index at: https://openworklabs.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create organization LLM provider

> Creates a new organization-scoped LLM provider from either a models.dev provider template or a pasted custom configuration.



## OpenAPI

````yaml /openapi.json post /v1/llm-providers
openapi: 3.1.0
info:
  title: Den API
  description: >-
    OpenAPI spec for the Den control plane API.


    Authentication:

    - Use `Authorization: Bearer <session-token>` for user-authenticated routes
    that require a Den session.

    - Use `x-api-key: <den-api-key>` for API-key-authenticated routes that
    accept organization API keys.

    - Public routes like health and documentation do not require authentication.


    Swagger tip: use the security schemes in the Authorize dialog to set either
    `bearerAuth` or `denApiKey` before trying protected endpoints.
  version: dev
servers:
  - url: https://api.openworklabs.com
security: []
tags:
  - name: System
    description: Service health and operational routes.
  - name: Organizations
    description: Top-level organization creation and context routes.
  - name: Invitations
    description: Invitation preview, acceptance, creation, and cancellation routes.
  - name: API Keys
    description: Organization API key management routes.
  - name: Members
    description: Organization member management routes.
  - name: Roles
    description: Organization custom role management routes.
  - name: Teams
    description: Organization team management routes.
  - name: Templates
    description: Organization shared template routes.
  - name: LLM Providers
    description: Organization LLM provider catalog, configuration, and access routes.
  - name: Skills
    description: Organization skill authoring and sharing routes.
  - name: Skill Hubs
    description: Organization skill hub management and access routes.
  - name: Workers
    description: Worker lifecycle, billing, and runtime routes.
  - name: Worker Runtime
    description: Worker runtime inspection and upgrade routes.
  - name: Worker Activity
    description: Worker heartbeat and activity reporting routes.
  - name: Admin
    description: Administrative reporting routes.
  - name: Users
    description: Current user and membership routes.
paths:
  /v1/llm-providers:
    post:
      tags:
        - LLM Providers
      summary: Create organization LLM provider
      description: >-
        Creates a new organization-scoped LLM provider from either a models.dev
        provider template or a pasted custom configuration.
      operationId: postV1LlmProviders
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                name:
                  type: string
                  minLength: 1
                  maxLength: 255
                source:
                  type: string
                  enum:
                    - models_dev
                    - custom
                providerId:
                  type: string
                  minLength: 1
                  maxLength: 255
                modelIds:
                  minItems: 1
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 255
                customConfigText:
                  type: string
                  minLength: 1
                apiKey:
                  type: string
                  maxLength: 65535
                memberIds:
                  maxItems: 500
                  type: array
                  items:
                    description: >-
                      Den TypeID with 'om_' prefix and a 26-character base32
                      suffix.
                    format: typeid
                    type: string
                    minLength: 29
                    maxLength: 29
                    pattern: ^om_.*
                teamIds:
                  maxItems: 500
                  type: array
                  items:
                    description: >-
                      Den TypeID with 'tem_' prefix and a 26-character base32
                      suffix.
                    format: typeid
                    type: string
                    minLength: 30
                    maxLength: 30
                    pattern: ^tem_.*
              required:
                - name
                - source
      responses:
        '201':
          description: Organization LLM provider created successfully.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/LlmProviderResponse'
        '400':
          description: The provider creation request was invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InvalidRequestError'
        '401':
          description: The caller must be signed in to create organization LLM providers.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthorizedError'
        '404':
          description: A referenced provider, model, member, or team could not be found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundError'
components:
  schemas:
    LlmProviderResponse:
      type: object
      properties:
        llmProvider:
          type: object
          properties: {}
          additionalProperties: {}
      required:
        - llmProvider
    InvalidRequestError:
      type: object
      properties:
        error:
          type: string
          const: invalid_request
        details:
          type: array
          items:
            type: object
            properties:
              message:
                type: string
              path:
                type: array
                items:
                  anyOf:
                    - type: string
                    - type: number
            required:
              - message
            additionalProperties: {}
      required:
        - error
        - details
    UnauthorizedError:
      type: object
      properties:
        error:
          type: string
          const: unauthorized
      required:
        - error
    NotFoundError:
      type: object
      properties:
        error:
          type: string
        message:
          type: string
      required:
        - error

````